public class BListe {
	Balon etkin;
	int katNumaras;

	public BListe(int katNumaras) {// constructor
		this.katNumaras = katNumaras;
		etkin = null;
	}

	public void Ekle(int no) {// bal diziye eleman ekler.
		if (etkin == null) {// liste yeni yaratlyorsa;
			Balon yeniBalon = new Balon(no);
			etkin = yeniBalon;
			etkin.sonraki = etkin;// bal listeyi dairesel hale getirmek iin
		} else {// listede birden fazla eleman varsa;
			Balon yeniBalon = new Balon(no);
			Balon simdiki = etkin, gecici = etkin;
			do {
				gecici = gecici.sonraki;
				simdiki = gecici.sonraki;
			} while (simdiki != etkin);
			gecici.sonraki = yeniBalon;
			yeniBalon.sonraki = etkin;
		}
	}

	public void patlat(int n) {
		Balon kaldi = etkin.sonraki;// silinecek olan balon
		if (n == 1) {//eer balonlar teker teker silmemiz isteniyorsa
			while (kaldi.sonraki != etkin) {
				kaldi = kaldi.sonraki;
			}
			System.out.println(katNumaras+".kattaki "+n+".sradaki balonlar patlatlmaktadr. "+"\nListedeki balonlar:\n");
			yazdir();
			while (doluMu()) {
				System.out.println("\nSilinen; ");
				etkin.yazdir();
				kaldi.sonraki = etkin.sonraki;
				etkin = etkin.sonraki;
				System.out.println("\nListedeki balonlar:\n");
				yazdir();
			}
		} else {
			System.out.print("\n"+katNumaras+".katta ilk balondan itibaren her "+n+".balon patlatlmaktadr.\n\n");
			while (doluMu()) {
				System.out.println(katNumaras+".katta kalan balonlar:");
				yazdir();
				int sayac = 1;
				while (sayac < n - 1) {// n defa dnmek iin..
					sayac++;
					etkin = etkin.sonraki;
					kaldi = kaldi.sonraki;
				}
				System.out.println("\n"+katNumaras+".katta "+"patlatlan; ");
				kaldi.yazdir();// her turda kat numaras ve n deerinin
								// yazdrlmas
				// istenmitir.
				System.out.println();// bir satr alta geelim
				etkin.sonraki = kaldi.sonraki;
				etkin = etkin.sonraki;
				kaldi = kaldi.sonraki.sonraki;
			}// dngden kldnda elimizde sadece bir balon kalm
				// olacaktr.
		}
		System.out.println("\n\n"+katNumaras+".katta "+"kalan;\t");
		etkin.yazdir();// onu da ekrana yazdralm.
	}

	public void yazdir() {
		Balon dolas;// listemiz dairesel olduu iin sonuna gelinip
		// gelinmediini anlamak iin ayrca bir balon oluturmak
		// lazmdr.
		dolas = etkin;
		do {
			dolas.yazdir();// ve dolarken elemanlar balon snfnda bulunan
			// yazdr yardmyla teker teker yazdrr.
			dolas = dolas.sonraki;
		} while (dolas != etkin);
	}

	public boolean doluMu() {// patlat metodu iin gereklidir.
		if (etkin == etkin.sonraki)// etkin kendine eit olduunda
			// yani bal listede sadece bir balon kaldnda
			// doluMu sorusuna "hayr bo" yantn verir
			return false;
		else
			return true;
	}

}
