/* Class: Musteri
 * Author: Didem KAYALI
 * 
 * Mteri bilgilerinin tutulduu veri snfdr. Normal
 * sral bekleme bilgileri FIFOBeklemeSuresi deikeninde
 * tutulurken ncelikli kuyrukta ne kadar bekledii
 * PBeklemeSuresi deikeninde tutulmaktadr.
 */

public class Musteri {
	public final int musteriNo;
	public final int islemSuresi;
	public Musteri sonraki;
	public int FIFOBeklemeSuresi;
	public int PBeklemeSuresi;

	/*
	 * Musteri snf iin iki constructor bulunmaktadr. Mterileri hem normal
	 * kuyrukta hem de ncelikli kuyrukta sraladktan sonra ne kadar
	 * beklediklerini karlatrmak iin iki bekleme srsinin de ne kadar
	 * olduunu bilmek nemlidir.
	 * 
	 * Programda nce standart kuyruk simle edilir. Daha sonra buradan gelen
	 * verileri de kullanarak ncelikli kuyruu simle etmek zere kuyruk
	 * yeniden oluturulur. Bu yeniden oluturma esnasnda standart bekleme
	 * sreleri daha nce hesaplanm olduu iin mteri bilgileri iine
	 * atlabilir.
	 */
	public Musteri(int musteriNo, int islemSuresi) {
		this.musteriNo = musteriNo;
		this.islemSuresi = islemSuresi;
		this.FIFOBeklemeSuresi = 0;
	}

	public Musteri(int musteriNo, int islemSuresi, int FIFOBeklemeSuresi) {
		this.musteriNo = musteriNo;
		this.islemSuresi = islemSuresi;
		this.FIFOBeklemeSuresi = FIFOBeklemeSuresi;
	}

}
